/*

Send a command to an ARexx port

Example:

rexx WORKBENCH ICON ROOT "Ram Disk" OPEN

Compile with

gcc -Wall -D__USE_INLINE__ rexx.c -o rexx -lauto

*/

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/rexxsyslib.h>
#include <string.h>

int main (void)

{
struct RDArgs *rdargs;
struct {
	char *port;
	char *command;
	} args;
struct MsgPort *arexxport;
struct MsgPort *replyport;
struct RexxMsg *rexxmsg;
int retc = RETURN_ERROR;

if ((rdargs = ReadArgs ("PORT/A,COMMAND/F",(APTR)&args,NULL)))
	{
	Printf ("port    = <%s>\n",args.port);
	Printf ("command = <%s>\n",args.command);

	if ((replyport = CreateMsgPort()))
		{
		if ((rexxmsg = CreateRexxMsg (replyport,NULL,NULL)))
			{
			rexxmsg->rm_Args[0] = args.command;
			rexxmsg->rm_Action = RXCOMM | RXFF_RESULT;

			if (FillRexxMsg (rexxmsg,1,0))
				{
				if ((arexxport = FindPort (args.port)))
					{
					PutMsg (arexxport,&rexxmsg->rm_Node);
					WaitPort (replyport);
					GetMsg (replyport);
					Printf ("RC      = %ld\n",rexxmsg->rm_Result1);
					if (rexxmsg->rm_Result1 == 0 && rexxmsg->rm_Result2)
						{
						Printf ("RESULT  = <%s>\n",(STRPTR)rexxmsg->rm_Result2);
						DeleteArgstring ((UBYTE *)rexxmsg->rm_Result2);
						}
					retc = RETURN_OK;
					}
				else
					{
					SetIoErr (ERROR_OBJECT_NOT_FOUND);
					PrintFault (IoErr(),args.port);
					}
				
				ClearRexxMsg (rexxmsg,1);
				}

			DeleteRexxMsg (rexxmsg);
			}

		DeleteMsgPort (replyport);
		}

	FreeArgs (rdargs);
	}
else
	PrintFault (IoErr(),NULL);

return (retc);
}
